#include <stdio.h>
#include <sys/utsname.h>
#include <pwd.h>


#define SQR(x) ((x)*(x))

#ifndef NDEBUG
#define Debug printf
#else
#define Debug //
#endif


unsigned int make_num(unsigned char *s1,unsigned char *s2,int len)
{
    unsigned int r=0;
    
    while (len>0 && *s1!=0 && *s2!=0) { 
	r+=((*s1)+(*s2));
	Debug("result: %x (%x)\n",r,*s1 + *s2);
	s1++;
	s2++;
	len--;
    }
	
    return r;
}

unsigned int do_math(char *s1,char *s2)
{
    int i=0;
    unsigned int x=0,y=0,r=0;
    
    if (strlen(s1)!=18 || strlen(s2)!=18)
	return 0;

    x=make_num(s1,s2,6);
    Debug("Produced x: 0x%x\n",x);
    y=make_num(s1+6,s2+6,6);
    Debug("Produced y: 0x%x\n",y);
    r=make_num(s1+12,s2+12,6);
    Debug("Produced r: 0x%x\n",r);
    
    if (SQR(x)+SQR(y)==SQR(r)) 
	return r;
	
    return 0;

}





void replace(char *d,int l,char *s)
{

    while (l-->0) {
	if ((*s=='\0') || (*d=='\0'))
	    break;
	*d++=*s++;
    }
    
}

char *merge(char *u,char *n,char *v)
{
    char u1[]="connor";
    char n1[]="skynet";
    char v1[]="tx2000";
    int len=0;
    char *r;
    int i;
    
    replace(u1,6,u);
    Debug("New username: \'%s\'\n",u1);
    replace(n1,6,n);
    Debug("New nodename: \'%s\'\n",n1);
    replace(v1,6,v);
    Debug("New kver: \'%s\'\n",v1);
    
    r=malloc(18+1);
    if (r==NULL) {
	fprintf(stderr,"Internal Error #923\n");
	exit(1);
    }
    
    i=0;
    while (i<6) {
	r[i*3]=u1[i];
	r[i*3+1]=n1[i];
	r[i*3+2]=v1[i];
	i++;
    }
    Debug("Final pass-phrase: \'%s\'\n",r);
    
    
    return r;
}
	

int main(void)
{
    struct utsname info;
    struct passwd *pwd;
    char *username;
    char *nodename;
    char *kver;
    char *full;
    char key[19];
    FILE *fp;
    unsigned int i;
    
    /* Open file and retrieve key */
    if ( (fp=fopen("auth.key","r"))==NULL) {
	fprintf(stderr,"Authentication Error #021\n");
	exit(1);
    }
    
    if (fread(key,1,18,fp)!=18) {
	fprintf(stderr,"Authentication Error #368\n");
	exit(1);
    }	
    key[18]='\0';
    Debug("Authentication key: %s\n",key);
    
    
    /* produce a pass phrase from name,nodename,release */
    pwd=getpwuid(getuid());
    username=pwd->pw_name;
    Debug("Login name: %s\n",username);

    uname(&info);
    kver=info.release;
    nodename=info.nodename;
    Debug("Computer name: %s %s\n",nodename,kver);
    full=merge(username,nodename,kver);
    
    /* check */
    if ( (i=do_math(full,key)) > 1)
	printf("Authentication successful \n");
    else
	printf("Failure %x\n",i);
    
}




