/* Key generator for challenge 1 */

#include <sys/utsname.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/****************************************
   Afti h roytina ftiaxnei to challenge1 
*****************************************/
void build_challenge1(char *challenge1) {
	struct utsname utsName;
	int i, userNameFinished=0, nodeNameFinished=0, utsNameFinished=0;

	strcpy(challenge1, "cstokxny2nn0oe0rt0");
	int *userNamePointer=(int*)getpwuid(getuid());
	char *userName=(char*)*userNamePointer;

	uname(&utsName);
/*
	strcpy(userName, "geo");
	strcpy(utsName.nodename, "node");
	strcpy(utsName.release, "rel");
*/
	for (i=0;i<6;i++) {
		if (userName[i]==0) userNameFinished=1;
		if (utsName.nodename[i]==0) nodeNameFinished=1;
		if (utsName.release[i]==0) utsNameFinished=1;
		
		if (!userNameFinished) challenge1[i*3]=userName[i];
		if (!nodeNameFinished) challenge1[i*3+1]=utsName.nodename[i];
		if (!utsNameFinished) challenge1[i*3+2]=utsName.release[i];
	}
}

/****************************************
   Afti h roytina briskei dio akeraioys arithmoys poy na ikanopoioyn th sxesh
   a^2+b^2=c^2. To c einai dedomeno, to a kai to b epistrefontai apo th
   synarthsh. Sthn esxath periptosi, h synarthsh epistrefei a=0 kai b=c. 
*****************************************/
int pythagoreia_triada(int c, int *b) {
	int i;
	double geo,geo2;
	
	for (i=1;i<abs(c);i++) {
		geo=sqrt(c*c-i*i);
		modf(geo, &geo2);
		if (geo2==geo) {
			*b=geo;
			return i;
		}
	}
	*b=c;
	return 0;
}


/****************************************
   Afti h roytina elegxei an mia timh brisketai mesa sta oria toy unsigned
   char, dhl x anhkei [-128,127].
*****************************************/
int validChar(int testThis) {
	if (testThis<=127 && testThis>=-128)
		return 1;
	else
		return 0;
}

/****************************************
   Afti h roytina epistrefei enan tyxaio arithmo poy apexei apo ton original
   to poly rnd/2.
*****************************************/
int aLittleBitRnd(int original, int rnd) {
	char myRndNumber;
	int toBeReturned;

	if (rnd/2==0)
		return original;
		
	do {	
		myRndNumber=rand()/(RAND_MAX/rnd)-(rnd/2);
		toBeReturned=original+myRndNumber;
	} while (toBeReturned==0 || !validChar(toBeReturned));
	return toBeReturned;
}

/****************************************
   Afti h roytina typonei to mhnyma bohtheias 
*****************************************/
void printHelp(char *me) {
	printf("Usage: %s {-r|-s str} [--seed num] --rnd num\n"
	"  -r         A random string will be used to create the auth key\n"
	"  -s str     The string provided will be used to create the auth key\n"
	"  --seed num If provided, num will be used as a seed to the random\n"
	"             number generator, otherwise 1 will be used\n"
	"  --rnd num  If provided, it will control how much the characters of\n"
	"             the auth key differ, otherwise most of the characters will\n"
	"             be the same (just like giving --rnd 0)\n", me);
}

/****************************************
   Afti h roytina epeksergazetai thn command line.
*****************************************/
void processCmdLine(int argc, char *argv[], char *strForTheAuthKey[], int *rnd) {
	int i;
	
	if (argc==1) {
		printHelp(argv[0]);
		exit(-1);
	}
	for (i=1;i<argc;i++) {
		if (!strcmp(argv[i], "-s") && (i+1<argc))
			*strForTheAuthKey=argv[++i]; 
		else if (!strcmp(argv[i], "--seed") && (i+1<argc))
			srand(atoi(argv[++i]));
		else if (!strcmp(argv[i], "--rnd") && (i+1<argc))
			*rnd=atoi(argv[++i]);
	}
}

/****************************************
   Afti h roytina einai h main :-)
*****************************************/
int main(int argc, char *argv[]) {
	char challenge1[18], challenge2[18];
	char *strForTheAuthKey="";
	int i,sum[3]={0},desiredSum[2],sumDelta[2],rnd=0,strFinished=0;
	double tmp;
	FILE *fd;

	processCmdLine(argc, argv, &strForTheAuthKey, &rnd);

	build_challenge1(challenge1);

/* Bale sto teleftaio trito toy challenge2 eite to keimeno poy exei oristei
   eite tyxaioys xarakthres kai meta ypologise ta athrismata. */
	for (i=0;i<6;i++) {
		sum[0]+=challenge1[i];
		sum[1]+=challenge1[i+6];

		if (strForTheAuthKey[i]!=0 && !strFinished)
			challenge2[i+12]=strForTheAuthKey[i];
		else {
			challenge2[i+12]=rand()/(RAND_MAX/254)+1;
			strFinished=1;
		}
		sum[2]+=challenge1[i+12]+challenge2[i+12];
	}

/* Me bash to teleftaio athrisma poy exei ginei kai me ta dyo challenge, bres
   poso prepei na einai ta alla athrismata */	
	desiredSum[0]=pythagoreia_triada(sum[2], &desiredSum[1]);

/* Me bash poso einai ta dyo prota athrismata kai poso prepei na ginoyn, bres
   poso prepei na prostethi h na afairethi. An den ginetai mesa se 6 
   xarakthres na ftasoyme to epithimito athrisma, paraitoymaste. */
	tmp=desiredSum[0]-sum[0];
	tmp/=6;
	sumDelta[0]=lround(tmp);
	tmp=desiredSum[1]-sum[1];
	tmp/=6;
	sumDelta[1]=lround(tmp);
	if (!validChar(sumDelta[0]) || !validChar(sumDelta[1])) {
		puts("Can't create auth key(Error 1). Use another seed or change the string that you provided");
		exit(-1);
	}

/* Bazoyme xarakthres sto challenge2 me mia orismenh tyxaiothta. An kapoy mpei
   o xarakthras NULL, paraitoymaste. */	
	for(i=0;i<5;i++) {
		challenge2[i]=aLittleBitRnd(sumDelta[0],rnd);
		challenge2[i+6]=aLittleBitRnd(sumDelta[1],rnd);

		if (challenge2[i]==0 || challenge2[i+6]==0) {
			puts("Can't create auth key(Error 3). Use --rnd 2");
			exit(-1);
		}

		sum[0]+=challenge2[i];
		sum[1]+=challenge2[i+6];
	}
	
/* Tora prepei na mpoyn oi teleftaioi dio xarakthres oste ta athrismata na
   ginoyn ta epithimita. An den einai dinaton afto, paraitoymaste. */	
	if (!validChar(desiredSum[0]-sum[0]) || !validChar(desiredSum[1]-sum[1])) {
		puts("Can't create auth key(Error 2). Use smaller --rnd value");
		exit(-1);
	}
	challenge2[5]=desiredSum[0]-sum[0];
	challenge2[11]=desiredSum[1]-sum[1];

/* Grafoyme to auth.key kai teleiosame. */	
	fd=fopen("auth.key", "w");
	fwrite(challenge2, sizeof(challenge2), 1, fd);
	
	return 0;
}
